//
// KonstruowanieSkładowych — klasa może przekazywać
//                     argumenty konstruktorom składowych
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;
int nastepnyNumerIndeksu = 1000; // pierwszy prawidłowy identyfikator studenta
class StudentId
{
  public:
    // domyślny konstruktor przypisuje identyfikatory sekwencyjnie
    StudentId()
    {
        wartosc = nastepnyNumerIndeksu++;
        cout << "Weź następny numer indeksu " << wartosc << endl;
    }
    // konstruktor, który pozwala użytkownikowi przypisać numer indeksu
    StudentId(int id)
    {
        wartosc = id;
        cout << "Przypisz numer indeksu " << wartosc << endl;
    }
  protected:
    int wartosc;
};
class Student
{
  public:
    Student(const char* pImie)
    {
        cout << "konstruktor klasy Student " << pImie << endl;
        imie = pImie;
        godzinySemestru = 0;
        gpa = 0.0;
    }
    // …inne składowe publiczne…
  protected:
    string imie;
    int godzinySemestru;
    double gpa;
    StudentId id;
};
int main(int nLiczbaArgumentow, char* pArgs[])
{
    // stwórz kilku studentów
    Student s1("Jacek");
    Student s2("Andrzej");
    // aby pozwolić użytkownikowi zobaczyć wynik programu
    // przed zakończeniem programu, poczekaj, aż użytkownik będzie gotowy
    cout << "Naciśnij Enter, aby kontynuować..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
