// SzablonWektora - implementuje wektor,
// który używa typu szablonu
#include <cstdlib>
#include <cstdio>
#include <iostream>
#include "szablonwektora.h"
using namespace std;
// funkcjaInt() — pracuje na zbiorze liczb całkowitych
void funkcjaInt()
{
    // stwórz wektor liczb całkowitych
    SzablonWektora<int> inty(10);
    // dodaj wartości do wektora
    cout << "Wprowadź wartości całkowite, aby dodać je do wektora\n"
         << "(Wprowadź liczbę ujemną, aby zakończyć):"
         << endl;
    for(;;)
    {
        int n;
        cin >> n;
        if (n < 0) { break; }
        inty.dodaj(n);
    }
    cout << "\nOto liczby, które wprowadziłeś:" << endl;
    for(int i = 0; i < inty.wielkosc(); i++)
    {
        cout << i << ":" << inty.wez() << endl;
    }
}
// Imiona — stwórz i pracuj z wektorem nazw
class Imie
{
  public:
    Imie() = default;
    Imie(string s) : imie(s) {}
    const string& wyswietl() { return imie; }
  protected:
    string imie;
};
void funkcjaImie()
{
    // stwórz wektor obiektów klasy Imie
    SzablonWektora<Imie> imiona(20);
    // dodaj wartości do wektora
    cout << "Wprowadź nazwy, aby dodać je do drugiego wektora\n"
         << "(Wpisz 'x', aby wyjść):" << endl;
    for(;;)
    {
        string s;
        cin >> s;
        if (s == "x" || s == "X") { break; }
        imiona.dodaj(Imie(s));
    }
    cout << "\nOto nazwy, które wprowadziłeś" << endl;
    for(int i = 0; i < imiona.wielkosc(); i++)
    {
        Imie& imie = imiona.wez();
        cout << i << ":" << imie.wyswietl() << endl;
    }
}
int main(int nLiczbaArgumentow, char* pArgs[])
{
    funkcjaInt();
    funkcjaImie();
    // aby pozwolić użytkownikowi zobaczyć wynik programu
    // przed zakończeniem programu, poczekaj, aż użytkownik będzie gotowy
    cout << "Naciśnij Enter, aby kontynuować..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
